/*
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * File:  "$Id: cav.h,v 1.2 2009/07/15 09:29:08 webmail Exp $"
 *
 * First Created on 2008/11/11 by jonas_liu@openfind.com.tw
 * Last Modified on "$Date: 2009/07/15 09:29:08 $" by  $Author: webmail $
 *
 * Copyright (c)2009 Openfind Information Technology INC.
 * All rights reserved.
 */

#ifndef	__CLAMAV_INIT_H
#define	__CLAMAV_INIT_H

#define	STR_BUFSIZE		512
#define	MAX_LOG_VIRUS	5

#define	STR_BUFSIZE		512
#define	MAX_LOG_VIRUS	5

typedef struct {
	char	szSrcFile[STR_BUFSIZE];
	char	szVirusName[MAX_LOG_VIRUS][STR_BUFSIZE];
	char	szVirusPath[MAX_LOG_VIRUS][STR_BUFSIZE];
	int	nVirusCnt;
	int	bInfected;
} CAV_SCAN_RESULT;

#define	CAV_TEMP_PATH			"/webmail/tmp"
#define	CAV_BASEDIR				"/webmail/ClamAV"
#define	CAV_ENGINE_DIRECTORY	CAV_BASEDIR"/lib"
#define	CAV_DATABASE_DIR		CAV_BASEDIR"/share/clamav"
#define	CLAM_AV_TMP_FILE		CAV_TEMP_PATH"/CLAMAV.XXXXXXXX"

// TCP scan API
int CAV_TcpInit(const char *pszServerList);
int CAV_TcpScan(const char *pszFileName, char *pszMemBlock, int nMemSize, char *pszMsg, int nMsgSize, int nScanMode);
int CAV_TcpDisconnect(void);

// local scan API
int CAV_LocalInit();
int CAV_LocalScan(const char *pszFileName, char *pszMemBlock, int nMemSize, char *pszMsg, int nMsgSize, int nScanMode);

// ClamAV Core Wrappers
int CAV_ScanInit();
int CAV_Scan(const char *pszFileName, CAV_SCAN_RESULT *pstResult);
int CAV_ScanBuf(const char *pszFileName, char *pszBuf, int nBufSize, CAV_SCAN_RESULT *pstResult);
int CAV_Terminate();

#endif
