/*
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * File:  "$Id: cav_log.c,v 1.2 2009/07/15 09:31:54 webmail Exp $"
 *
 * First Created on 2008/11/11 by jonas_liu@openfind.com.tw
 * Last Modified on "$Date: 2009/07/15 09:31:54 $" by  $Author: webmail $
 *
 * Copyright (c)2009 Openfind Information Technology INC.
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>

#include "version.h"

M2K_VER_ID("$Id: cav_log.c,v 1.2 2009/07/15 09:31:54 webmail Exp $");

#define LOG_TIMEFMT  "[%Y/%m/%d %T] "

static int s_logit2(char *filename, char *fmt, ...)
{
	time_t		  now;
	struct tm	  *p;
	FILE		   *flog;
	va_list args;
	char *buf;
	int n;
	char dbuf[32];

	if ( !filename || !*filename )
	   return 0;

	va_start(args, fmt);
	/*buf is from malloc*/
	time(&now);
	p = localtime(&now);
	if ( !(flog = fopen(filename, "a")) )
	   return -1;
	n = vasprintf(&buf, fmt, args);
	if ( buf == (char *) 0){
	   fclose(flog);
	   return -1;
	}
	va_end(args);
	strftime(dbuf, sizeof(dbuf), LOG_TIMEFMT, p);
	/*LOG_TIMEFMT has one additional space*/
	fprintf(flog, "%s%s\n", dbuf, buf);
	fclose(flog);
	free(buf);
	return n;
}

void 
_LOG(char *pcType, char *pcFile, int nLen, char *pcFunc, const char *fmt, ...) {
	static int	bEnabled = -1;
	va_list	args;
	char		szBuf[4096];
	
	if(-1 == bEnabled) {
		if(0 == access(CAV_BASEDIR"/enable_trace", F_OK))
			bEnabled = 1;
		else
			bEnabled = 0;
	}
	
	if(1 == bEnabled)	 {
		va_start(args, fmt);
   	vsnprintf(szBuf, sizeof(szBuf)-1, fmt, args);
		va_end(args);

		s_logit2(LOG_FILEPATH, "[%s:%d] [%s:%d, %s] %s", pcType, getpid(), pcFile, nLen, pcFunc, szBuf);
	}
}
