/*
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * File:  "$Id: bfd.h,v 1.1 2009/07/15 11:05:16 webmail Exp $"
 *
 * First Created on 2008/11/11 by jonas_liu@openfind.com.tw
 * Last Modified on "$Date: 2009/07/15 11:05:16 $" by  $Author: webmail $
 *
 * Copyright (c)2009 Openfind Information Technology INC.
 * All rights reserved.
 */

#ifndef __BFD_H
#define __BFD_H

#ifdef  __cplusplus
        extern "C" {
#endif
        
#define BFD_RBUF_SIZE  2048
#define BFD_WBUF_SIZE  2048

struct bfd {
   int  fd;
   char rbuf[BFD_RBUF_SIZE+1];
   int  ridx;
   char wbuf[BFD_WBUF_SIZE+1];
   int  widx;
};

int bfd_init(struct bfd *bd, int fd);
int bfd_write(struct bfd *bd, char *buf, size_t sz, int t, int flush);
int bfd_flush(struct bfd *bd, int t);
int bfd_read(struct bfd *bd, char *buf, size_t sz, int t);
int bfd_readrec(struct bfd *bd, char *buf, size_t bsz, char sep, int t);

#ifdef  __cplusplus
        }
#endif


#endif
