/*
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * File:  "$Id: tcp.h,v 1.1 2009/07/15 11:05:16 webmail Exp $"
 *
 * First Created on 2008/11/11 by jonas_liu@openfind.com.tw
 * Last Modified on "$Date: 2009/07/15 11:05:16 $" by  $Author: webmail $
 *
 * Copyright (c)2009 Openfind Information Technology INC.
 * All rights reserved.
 */

#ifndef __TCP_H
#define __TCP_H
#include <signal.h>

/*the maximum length socket_out() will accept*/
#define MAX_LISTEN_BACKLOG      10

#ifdef  __cplusplus
        extern "C" {
#endif
        

int srv_start(int port);
int srv_accept(int sfd);
int srv_accept2(int sfd, char *buf, int size);
int sock_out(int fd, int t,char *fmt, ...);
int sock_noblk(int fd);
int tcp_conn(const char *host, int port);
int linger_on(int fd);

/* unixdn.c */
int srv_unixdn_start(const char *pcUnixPath);
int unixdn_conn(const char *pcUnixPath);

/* setsignal.c */
int setsignal(int signo, void (*func)(int));

#ifdef  __cplusplus
        }
#endif

#endif/*__TCP_H*/
